#!/usr/bin/ruby
# encoding: utf-8

class AntibotResultFrame	
	def initialize(assi)
		@infected = nil
		@scanner = nil
		@int_drives = nil
		@ext_drives = nil
		@delete_on_failed_desinfect = false
		@truncate_instead_delete = false
		@backup_before_action = false
		@localbackup = true
		@assistant = assi
		@wdgt = Gtk::Alignment.new(0.5, 0.5, 0.8, 0.0)
		@vbox = Gtk::VBox.new(false, 5)
		@children = Array.new
		@children.push(Gtk::Label.new("Dies ist Platzhaltertext, der benutzt wird, um dieses Widget zu initialisieren. Nach abgeschlossenem Scan sollte der Platzhaltertext nicht mehr zu sehen sein. wenn Sie ihn  dennoch sehen, ist etwas schiefgelaufen."))
		@children[0].wrap = true
		@children.push(Gtk::Label.new("Es wurde keine Schadsoftware gefunden. Sie können zurück gehen und mit anderen Einstellungen einen erneuten Virenscan starten. Wählen Sie \"Abbrechen\", um den Computer neu zu starten"))
		@children[1].wrap = true
		@children.push(Gtk::Label.new("Es wurde in %FILECOUNT% Datei(en) Schadsoftware gefunden. Sie können mit nun Einstellungen für die Desinfektion einzelner Dateien festlegen und im nächsten Schritt die Reinigung durchführen. Falls die Zahl infizierter Dateien sehr hoch ist, verwenden Sie \"Zurück\" und starten Sie einen erneuten Scan mit sofortiger Desinfektion."))
		@children[2].wrap = true
		@children.push Gtk::HBox.new(false, 3)
		@progress = Gtk::ProgressBar.new
		# @progress.width_request = 330
		@children[3].width_request = 540 
		@children[3].pack_start(@progress, true, true, 3)
		@confbutton = Gtk::Button.new("Einstellungen")
		@confbutton.width_request = 90
		@children[3].pack_start(@confbutton, false, false, 0)
		@confbutton.signal_connect("clicked") { show_configuration }
		@desinfbutton = Gtk::Button.new("Start")
		@desinfbutton.width_request = 90
		@children[3].pack_start(@desinfbutton, false, false, 0)
		[ 0, 1, 2, 3 ].each { |n| @children[n].width_request = 540 } 
		@children.each { |w|
			@vbox.pack_start(w, true, false, 0)
		}
		@wdgt.add @vbox
	end
	attr_reader :wdgt 
	
	def show_results(int_drives, ext_drives, scanner)
		@scanner = scanner
		@int_drives = int_drives
		@ext_drives = ext_drives
		inf_count = 0
		scanner.infections.each { |k,v|
			puts "Partition UUID" + k.uuid
			v.each { |f|
				puts f.raw_infection 
				inf_count += 1
			}
		}
		puts "Infections total: " + inf_count.to_s
		@children.each { |w| w.hide_all }
		if inf_count < 1
			@children[1].show_all
			@assistant.set_page_title(@wdgt, "Auswertung")
		else
			@children[2].show_all
			@children[3].show_all
			@children[2].text = @children[2].text.gsub("%FILECOUNT%", inf_count.to_s) 
			@assistant.set_page_title(@wdgt, "Auswertung und Desinfektion")
		end
	end
	
	def show_configuration
		inf_count = 0 
		# puts @scanner.to_s
		# Create the dialog
		dialog = Gtk::Dialog.new("Einstellungen",
                             $main_application_window,
                             Gtk::Dialog::MODAL,
                             [ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_NONE ])
		drive_expanders = Hash.new
		vbox = Gtk::VBox.new(false, 5)
		checked_uuids = Array.new
		@scanner.infections.each { |k,v| 
			checked_uuids.push(k.uuid) unless v.nil? 
			#puts v.to_s 
		}
		@int_drives.each { |d|
			d.partitions.each { |p|
				if checked_uuids.include?(p.uuid)
					puts d.device.to_s + " " + p.device.to_s + " " + p.uuid.to_s
					tlines = Array.new
					inf = @scanner.infections[p]
					unless inf.nil?
						inf.each { |i|
							tlines.push i.create_list_entry
						}
					end
					table = Gtk::Table.new(tlines.size + 1, 6, false)
					if tlines.size > 0 
						note = " - " + tlines.size.to_s + " Fund(e)"
						ls = [ "N", "D", 
							"L", "Infizierte Datei", "Schadsoftware", "Information" ]
						0.upto(ls.size - 1) { |n|
							lab = Gtk::Label.new("<b>" + ls[n] + "</b>")
							lab.use_markup = true
							table.attach(lab, n, n+1, 0, 1, Gtk::SHRINK, Gtk::SHRINK, 0, 2)
						}
						
						lct = 1
						tlines.each { |tentry|
							table.attach(tentry[2], 0, 1, lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 0, 2)
							table.attach(tentry[3], 1, 2, lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 0, 2)
							table.attach(tentry[4], 2, 3, lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 0, 2)
							table.attach(tentry[0], 3, 4, lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 5, 2)
							table.attach(tentry[1], 4, 5, lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 5, 2)
							table.attach(tentry[5], 5, 6,lct, lct+1, Gtk::SHRINK, Gtk::SHRINK, 3, 2)
							lct += 1
						}
					else
						note = " - kein Fund"
					end
					drive_expanders[p.device] = Gtk::Expander.new("<b>" + d.device + ", Partition " + p.device.to_s + ", " + p.fs.to_s + " " + p.label.to_s + " " + p.human_size + note + "</b>", true)
					drive_expanders[p.device].use_markup = true
					if tlines.size > 0
						drive_expanders[p.device].expanded = true
					else
						drive_expanders[p.device].sensitive = false
					end
					drive_expanders[p.device].add(table)
					vbox.pack_start(drive_expanders[p.device], false, false, 0)
				end
			}
		}
		@ext_drives.each { |d|
			d.partitions.each { |p|
				puts d.device.to_s + " " + p.device.to_s + " " + p.uuid.to_s 
			}
		}
		oscrl = Gtk::ScrolledWindow.new
		oscrl.width_request = 650
		oscrl.height_request = 430
		oscrl.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
		oscrl.add_with_viewport vbox
		
		outbox = Gtk::VBox.new(false, 0)
		outbox.pack_start(oscrl, true, true, 0)
		delquest = Gtk::CheckButton.new("Löschen, wenn Desinfektion nicht möglich")
		trcquest = Gtk::CheckButton.new("Datei auf Null schrumpfen statt entfernen")
		bakquest = Gtk::CheckButton.new("Vor Löschen Sicherung erstellen")
		locradio = Gtk::RadioButton.new("Sicherung neben infizierter Datei erstellen")
		usbradio = Gtk::RadioButton.new(locradio, "Sicherung auf USB-Laufwerk erstellen")
		delquest.active = @delete_on_failed_desinfect
		delquest.signal_connect("clicked") { @delete_on_failed_desinfect = delquest.active? }
		trcquest.active = @truncate_instead_delete
		trcquest.signal_connect("clicked") { @truncate_instead_delete = trcquest.active? }
		bakquest.active = @backup_before_action
		bakquest.signal_connect("clicked") { @backup_before_action = bakquest.active? }
		usbradio.active = true if @localbackup == false
		locradio.signal_connect("clicked") { @localbackup = true if locradio.active? }
		usbradio.signal_connect("clicked") { @localbackup = false if usbradio.active? }
		[ delquest, trcquest, bakquest, locradio, usbradio ].each { |b| outbox.pack_start(b, false, false, 2) } 
		dialog.vbox.add(outbox)
		dialog.signal_connect('response') { dialog.destroy }
		dialog.show_all
		
	end
	
end