#!/usr/bin/ruby
# encoding: utf-8

class AntibotScanFrame
	
	def initialize(assi, drvscreen, optscreen, starttime=nil)
		# @wdgt = Gtk::Frame.new("Virenscan durchführen")
		@wdgt = Gtk::Alignment.new(0.5, 0.5, 0.8, 0.0)
		@assistent = assi
		@drivescreen = drvscreen
		@optionscreen = optscreen
		@starttime = starttime
		@starttime = Time.now if @starttime.nil?
		@scanner = nil
		scanlabel = Gtk::Label.new("Klicken Sie auf \"Virenscan starten\" um den Virenscan zu starten. Der Virenscan kann je nach Geschwindigkeit des Computers und Festplattenbelegung zwischen wenigen Minuten und vielen Stunden dauern. Ein Abbruch ist jederzeit möglich.")
		scanlabel.wrap = true
		scanlabel.width_request = 540
		scanvbox = Gtk::VBox.new(false, 3)
		scanvbox.pack_start(scanlabel, false, false, 5)
		@progress = Gtk::ProgressBar.new
		# @progress.width_request = 500
		scanvbox.pack_start(@progress, false, false, 5)
		buttonbox = Gtk::HBox.new(true, 3)
		@confirm = Gtk::Button.new("Virenscan starten")
		@cancel = Gtk::Button.new("Virenscan abbrechen")
		@confirm.signal_connect("clicked") {
			@assistent.set_page_complete(@wdgt, false)
			@cancel.sensitive = true
			@confirm.sensitive = false
			@progress.activity_mode = true
			run_scan
			@progress.activity_mode = false
			@cancel.sensitive = false
			@confirm.sensitive = true
		}
		@cancel.signal_connect("clicked") {
			@assistent.set_page_complete(@wdgt, true)
			@cancel.sensitive = false
			kill_scan
			# @confirm.sensitive = true
		}
		@cancel.sensitive = false
		buttonbox.pack_start(@cancel, true, true, 2)
		buttonbox.pack_start(@confirm, true, true, 2)
		scanvbox.pack_start(buttonbox, false, false, 5)
		@wdgt.add scanvbox
		
	end
	attr_accessor :wdgt, :scanner
	
	def kill_scan
		@scanner.kill_scan
	end
	
	def run_scan
		msg = "Something strange happened..."
		logdir = nil
		if system("mountpoint -q /lesslinux/antibot")
			logdir = "/lesslinux/antibot/antibot3/Protokolle/" + @starttime.strftime("%Y%m%d-%H%M%S") 
			system("mkdir -p '#{logdir}'")
			system("dmidecode -t system > '#{logdir}/computer-identifikation.txt'")
		end
		@scanner = AntibotAviraScanner.new(@drivescreen, @optionscreen.parameter_array, logdir)
		success, msg = @scanner.update_signatures(14400, @progress)
		# return 1
		if success == false
			d = dialog_general_info("Update fehlgeschlagen", msg.to_s)
			puts d.to_s
			return false if d == false
		end
		@scanner.prepare_scan(@progress)
		@scanner.run_scan(@progress) unless @scanner.killed == true
		@assistent.set_page_complete(@wdgt, true)
		@assistent.current_page = @assistent.current_page + 1
	end
	
	def dialog_general_info(head, message)
		dialog = Gtk::Dialog.new(
			head,
			$main_application_window,
			Gtk::Dialog::MODAL,
			[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
			[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]
		)
		dialog.has_separator = false
		label = Gtk::Label.new(message)
		label.wrap = true
		image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)
		hbox = Gtk::HBox.new(false, 5)
		hbox.border_width = 10
		hbox.pack_start_defaults(image);
		hbox.pack_start_defaults(label);
		dialog.vbox.add(hbox)
		dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
		dialog.show_all
		retval = false
		dialog.run { |response|
			case response
			when Gtk::Dialog::RESPONSE_OK
				puts "OK clicked!"
				retval = true
			else
				puts "Cancel clicked!"
				retval = false
			end
		}
		dialog.destroy
		return retval
	end
	
end