#!/usr/bin/ruby
# encoding: utf-8

require 'gtk2'
require 'vte'
require "rexml/document"
require 'optparse'

require "MfsDiskDrive.rb"
require "MfsSinglePartition.rb"
require "AntibotDriveScreen.rb"
require "AntibotOptionScreen.rb"
require "AntibotScanFrame.rb"
require "AntibotPrereqScreen.rb"
require "AntibotAviraScanner.rb" 
require "AntibotResultFrame.rb"
require "AntibotInfectedFile.rb"
require "AntibotMisc.rb"

# Create a new assistant widget with no pages. */
assistant = Gtk::Assistant.new
assistant.set_size_request(600, 350)   # 450, 300
assistant.signal_connect('destroy') { Gtk.main_quit }

# Append the page for checking prerequisites
prescr = AntibotPrereqScreen.new(assistant)
assistant.append_page(prescr.wdgt)
assistant.set_page_title(prescr.wdgt, "Voraussetzungen für Virenscan")
assistant.set_page_complete(prescr.wdgt, prescr.complete)

# Append the page for drive selection
dscrl = Gtk::ScrolledWindow.new
dscrn = AntibotDriveScreen.new
dscrl.add_with_viewport dscrn.wdgt
dscrl.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
assistant.append_page(dscrl) 
assistant.set_page_title(dscrl, "Laufwerke auswählen")
assistant.set_page_complete(dscrl, true)

# Append the page for scan options
oscrn = AntibotOptionScreen.new
assistant.append_page(oscrn.wdgt)
assistant.set_page_title(oscrn.wdgt, "Einstellungen für Virenscan")
assistant.set_page_complete(oscrn.wdgt, true)

# Append the page for scan start
scnfr = AntibotScanFrame.new(assistant, dscrn, oscrn, Time.now)
assistant.append_page(scnfr.wdgt)
assistant.set_page_title(scnfr.wdgt, "Virenscan starten")
assistant.set_page_type(scnfr.wdgt, Gtk::Assistant::PAGE_PROGRESS)
assistant.set_page_complete(scnfr.wdgt, false)

# Append the results page
resfr = AntibotResultFrame.new(assistant)
assistant.append_page(resfr.wdgt)
assistant.set_page_title(resfr.wdgt, "Auswertung")
assistant.set_page_type(resfr.wdgt, Gtk::Assistant::PAGE_PROGRESS)
assistant.set_page_complete(resfr.wdgt, true)

# Current page for re-reading drivelist

assistant.set_forward_page_func { |curr_pg|
	puts "Current page:     " + curr_pg.to_s
	puts "Different method: " + assistant.current_page.to_s 
	assistant.show_all
	if assistant.current_page == 1 && curr_pg == 2
		dscrn.reread_drivelist
	elsif assistant.current_page == 4 && curr_pg == 4
		puts "Jumping to results page"
		resfr.show_results(dscrn.int_drives, dscrn.ext_drives, scnfr.scanner)
	else
		dscrn.dump_marked
	end
	while (Gtk.events_pending?)
		Gtk.main_iteration
	end
	curr_pg + 1
}

assistant.show_all
Gtk.main